# Class SecureCacheResponse

java.lang.Object
java.net.CacheResponse
java.net.SecureCacheResponse

public abstract class SecureCacheResponse extends CacheResponse
Represents a cache response originally retrieved through secure means, such as TLS.

Since:
  1.5

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SecureCacheResponse()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract String`
  `getCipherSuite()`
  Returns the cipher suite in use on the original connection that retrieved the network resource.
  `abstract List<Certificate>`
  `getLocalCertificateChain()`
  Returns the certificate chain that were sent to the server during handshaking of the original connection that retrieved the network resource.
  `abstract Principal`
  `getLocalPrincipal()`
  Returns the principal that was sent to the server during handshaking in the original connection that retrieved the network resource.
  `abstract Principal`
  `getPeerPrincipal()`
  Returns the server's principal which was established as part of defining the session during the original connection that retrieved the network resource.
  `abstract List<Certificate>`
  `getServerCertificateChain()`
  Returns the server's certificate chain, which was established as part of defining the session in the original connection that retrieved the network resource, from cache.
  `Optional<SSLSession>`
  `getSSLSession()`
  Returns an `Optional` containing the `SSLSession` in use on the original connection that retrieved the network resource.

  ### Methods declared in class CacheResponse

  `getBody, getHeaders`
  Modifier and Type
  Method
  Description
  `abstract InputStream`
  `getBody()`
  Returns the response body as an InputStream.
  `abstract Map<String, List<String>>`
  `getHeaders()`
  Returns the response headers as a Map.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SecureCacheResponse

    public SecureCacheResponse()
    Constructor for subclasses to call.

- ## Method Details

  - ### getCipherSuite

    public abstract String getCipherSuite()
    Returns the cipher suite in use on the original connection that retrieved the network resource.
    Returns:
      a string representing the cipher suite

  - ### getLocalCertificateChain

    public abstract List<Certificate> getLocalCertificateChain()
    Returns the certificate chain that were sent to the server during handshaking of the original connection that retrieved the network resource. Note: This method is useful only when using certificate-based cipher suites.
    Returns:
      an immutable List of Certificate representing the certificate chain that was sent to the server. If no certificate chain was sent, null will be returned.
    See Also:
      - `getLocalPrincipal()`

  - ### getServerCertificateChain

    public abstract List<Certificate> getServerCertificateChain() throws SSLPeerUnverifiedException
    Returns the server's certificate chain, which was established as part of defining the session in the original connection that retrieved the network resource, from cache. Note: This method can be used only when using certificate-based cipher suites; using it with non-certificate-based cipher suites, such as Kerberos, will throw an SSLPeerUnverifiedException.
    Returns:
      an immutable List of Certificate representing the server's certificate chain.
    Throws:
      `SSLPeerUnverifiedException` - if the peer is not verified.
    See Also:
      - `getPeerPrincipal()`

  - ### getPeerPrincipal

    public abstract Principal getPeerPrincipal() throws SSLPeerUnverifiedException
    Returns the server's principal which was established as part of defining the session during the original connection that retrieved the network resource.
    Returns:
      the server's principal. Returns an X500Principal of the end-entity certificate for X509-based cipher suites, and KerberosPrincipal for Kerberos cipher suites.
    Throws:
      `SSLPeerUnverifiedException` - if the peer was not verified.
    See Also:
      - `getServerCertificateChain()`
      - `getLocalPrincipal()`

  - ### getLocalPrincipal

    public abstract Principal getLocalPrincipal()
    Returns the principal that was sent to the server during handshaking in the original connection that retrieved the network resource.
    Returns:
      the principal sent to the server. Returns an X500Principal of the end-entity certificate for X509-based cipher suites, and KerberosPrincipal for Kerberos cipher suites. If no principal was sent, then null is returned.
    See Also:
      - `getLocalCertificateChain()`
      - `getPeerPrincipal()`

  - ### getSSLSession

    public Optional<SSLSession> getSSLSession()
    Returns an `Optional` containing the `SSLSession` in use on the original connection that retrieved the network resource. Returns an empty `Optional` if the underlying implementation does not support this method.
    Implementation Requirements:
      For compatibility, the default implementation of this method returns an empty `Optional`. Subclasses should override this method with an appropriate implementation since an application may need to access additional parameters associated with the SSL session.
    Returns:
      an `Optional` containing the `SSLSession` in use on the original connection
    Since:
      12
    See Also:
      - `SSLSession`